<?php
/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

define( '_VALID_OSM', TRUE );
define( '_PATH', './' );
$DEBUG = FALSE;
if($DEBUG) error_reporting(E_ALL);

include("./config.inc.php");
include("./libraries/functions.inc.php");
#include("./libraries/classes.php");
include("./libraries/GeoCalc.class.php");
require('./libraries/phplot/phplot.php');

setlocale (LC_TIME, $cfg['config_locale']);
include("./languages/".get_lang($cfg['config_language']).".php");

$id 	= getUrlParam('HTTP_GET', 'INT', 'id');
$width 	= getUrlParam('HTTP_GET', 'INT', 'width');
$height	= getUrlParam('HTTP_GET', 'INT', 'height');
$name 	= getUrlParam('HTTP_GET', 'STRING', 'name');
$begin_timestamp 	= getUrlParam('HTTP_GET', 'INT', 'bts');
$end_timestamp 		= getUrlParam('HTTP_GET', 'INT', 'ets');
$filter	= getUrlParam('HTTP_GET', 'INT', 'filter');
$type 	= getUrlParam('HTTP_GET', 'STRING', 'type');

if(!$width)
	$width = $cfg['chart_width'];
if(!$height)
	$height = $cfg['chart_height'];
if(!$filter)
	$filter = $cfg['alt_data_filter_mva'];

// connect to database
$link = db_connect_h($cfg['db_host'], $cfg['db_name'], $cfg['db_user'], $cfg['db_password']);


// chart type: altitude against time
if($type == "alt_time") {
	$query = "SELECT `altitude`, `timestamp` FROM `${cfg['db_table_prefix']}gpx_import` 
				WHERE `gpx_id` = '$id' ";
	if(isset($begin_timestamp) && isset($end_timestamp)) {
		$query .= "AND UNIX_TIMESTAMP(`timestamp`) 
					BETWEEN $begin_timestamp AND $end_timestamp ";
	}
	$query .= "ORDER BY `timestamp`; ";

	$result = db_query($query);
	
	if(mysql_num_rows($result)) {
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			if($row['altitude']) {
				$td = array('', strtotime($row['timestamp']), $row['altitude']);
				$data[] = $td;
			}
		}
	}

	// filter altitude data
	if($filter) {
		// extract alt data from trackpoints
		$alt_data = array_extract_multidim($data, NULL, 2);
		// process moving average filter
		$filtered_alt_data = moving_average_m($alt_data, $filter, 'MODE_ALL');
		// write back filtered alt data to trackpoints array
		array_infect_multidim(&$data, NULL, 2, $filtered_alt_data);
	}
	
	$plot = new PHPlot($width, $height);
	$plot->SetPlotType('lines');
	$plot->SetXLabelType('time', '%H:%M');
	$plot->setPrecisionY(0);
	$plot->setTitle(_CHART_ELEVATION_TITLE);
	$plot->setXTitle(_CHART_AXIS_TIME .' / hh:mm');
	$plot->setYTitle(_CHART_AXIS_ELE .' / m');
	$plot->setLegend(_CMN_GPX_ID .': '.$id);

	$plot->SetDataValues($data);
	$plot->SetDataType('data-data');
	$plot->DrawGraph();
}

// chart type: altitude against distance
if($type == "alt_dist") {
	$query = "SELECT * FROM `${cfg['db_table_prefix']}gpx_import` 
				WHERE `gpx_id` = '$id' ";
	if(isset($begin_timestamp) && isset($end_timestamp)) {
		$query .= "AND UNIX_TIMESTAMP(`timestamp`) 
					BETWEEN $begin_timestamp AND $end_timestamp ";
	}
	$query .= "ORDER BY `timestamp`; ";

	$result = db_query($query);
	
	if(mysql_num_rows($result)) {
		$pt = array('i'=>0, 'x'=>0, 'y'=>0, 'xold'=>0, 'yold'=>0, 'a'=>0, 'aold'=>0);
		$dist=0;
		$oGC = new GeoCalc();
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$pt['i']++;
			$pt['yold'] = $pt['y'];
			$pt['xold'] = $pt['x'];
			$pt['aold'] = $pt['a'];
			$pt['y'] = $row['latitude'] /1000000;
			$pt['x'] = $row['longitude'] /1000000;
			$pt['a'] = $row['altitude'];
			
			if($pt['xold'] && $pt['yold'] && $row['altitude']) {
				// get distance between 2 trackpoints
				$distP2P = $oGC->GCDistance($pt['y'], $pt['x'], $pt['yold'], $pt['xold']);
				if(!$distP2P || is_nan($distP2P)) {
					if($DEBUG) {
						out($row['timestamp']." :  xo=".$pt['xold']." yo=".$pt['yold'].
							" x=".$pt['x']." y=".$pt['y']." d=".$distP2P, 'OUT_DEBUG');
					}
					continue;
				}
				// sum point-to-point distances
				$dist += $distP2P;
				// make array for data points used in graph
				$td = array('', $dist, $row['altitude']);
				$data[] = $td;
			}
		}
	}
	
	// filter altitude data
	if($filter) {
		// extract alt data from trackpoints
		$alt_data = array_extract_multidim($data, NULL, 2);
		// process moving average filter
		$filtered_alt_data = moving_average_m($alt_data, $filter, 'MODE_ALL');
		// write back filtered alt data to trackpoints array
		array_infect_multidim(&$data, NULL, 2, $filtered_alt_data);
		if($DEBUG) {
			echo "alt_data:\n";				print_r($alt_data);
			echo "filtered_alt_data:\n";	print_r($filtered_alt_data);
			echo "data:\n";					print_r($data);
		}
	}
	
	// TODO: this is really nice, but should be done in traces.php
	// calculate climbing/falling altitude difference sum
	/*
	if($filter)
		$altdata = $filtered_alt_data;
	else
		$altdata = array_extract_multidim($data, NULL, 2);
	
	for($i=0; $i<sizeof($altdata); $i++) {
		if($altdata[$i] > $altdata[$i-1] && $altdata[$i-1]>0)
		    $altdiff_climb += ($altdata[$i] - $altdata[$i-1]);
		if($altdata[$i] < $altdata[$i-1] && $altdata[$i]>0)
		    $altdiff_fall += ($altdata[$i] - $altdata[$i-1]);
	}
	*/
	if($DEBUG)	exit();
	
	// create plot 
	$plot = new PHPlot($width, $height);
	$plot->SetPlotType('lines');
	$plot->SetXLabelType('data', 0 , ' km', ' m');
	$plot->setPrecisionX(1);
	$plot->setPrecisionY(0);
	$plot->setTitle(_CHART_ELEVATION_TITLE);
	$plot->setXTitle(_CHART_AXIS_DIST . ' / km');
	$plot->setYTitle(_CHART_AXIS_ELE .' / m');
	$plot->setLegend(_CMN_GPX_ID .': '.$id);
	$plot->SetDataValues($data);
	$plot->SetDataType('data-data');
	$plot->DrawGraph();
}
?>